<template>
  <div style="margin:50px 20px 50px">
    <div class="md-layout-item md-medium-size-100 md-xsmall-size-100 md-size-100">
      <md-table>
        <md-table-toolbar>
          <div class="md-toolbar-section-start">
            <h1 class="md-title">Generate a bonus</h1>
          </div>
        </md-table-toolbar>

        <md-table-row>
          <md-table-head>End time</md-table-head>
          <md-table-head>Percent</md-table-head>
          <md-table-head></md-table-head>
        </md-table-row>
        <md-table-row>
          <md-table-cell style="position: relative;">
            <md-field :class="{'md-invalid': errors.has('generate.params_end_time')}">
              <datetime-picker input-type="timestamp"
                               data-vv-as="end time"
                               v-validate="'required'"
                               name="params_end_time"
                               disabled
                               data-vv-scope="generate"
                               v-model="params.end_time"
                               format="yyyy-MM-dd HH:mm:ss">
              </datetime-picker>
              <span class="md-error" v-if="errors.has('generate.params_end_time')">{{ errors.first('generate.params_end_time') }}</span>
            </md-field>
          </md-table-cell>
          <md-table-cell>
            <md-field :class="{'md-invalid': errors.has('generate.params_percent')}">
              <md-input
                data-vv-as="percent"
                name="params_percent"
                v-model="params.percent"
                v-validate="'required|min_value:0|decimal:18'"
                data-vv-scope="generate"
                data-vv-validate-on="none"
                type="number">
              </md-input>
              <span style="position: absolute; right: 15px; top: 50%;">%</span>
              <span class="md-error" v-if="errors.has('generate.params_percent')">{{ errors.first('generate.params_percent') }}</span>
            </md-field>
          </md-table-cell>
          <md-table-cell>
            <md-button class="md-raised" @click="showDialogConfirmGenerate(params)">Generate</md-button>
          </md-table-cell>
        </md-table-row>
      </md-table>
    </div>

    <data-table ref="datatable" :get-data="getBonuses" class="getBonuses" :limit="10">
      <template slot="table-toolbar">
        <div class="md-toolbar-section-start">
          <h1 class="md-title">Bonuses</h1>
        </div>
      </template>

      <md-table-head>#</md-table-head>
      <md-table-head>End Time</md-table-head>
      <md-table-head>Percent</md-table-head>
      <md-table-head></md-table-head>

      <template slot="body" slot-scope="{ item, index }">
        <md-table-row :key="item.timestamp">
          <md-table-cell> {{ index + 1 }}</md-table-cell>
          <md-table-cell>
            <md-field :class="{'md-invalid': errors.has(item.id + '_timestamp')}">
              <datetime-picker input-type="timestamp"
                               data-vv-as="end time"
                               :name="item.id + '_timestamp'"
                               v-validate="'required'"
                               v-model="item.timestamp"
                               data-vv-validate-on="none"
                               format="yyyy-MM-dd HH:mm:ss">
              </datetime-picker>
              <span class="md-error" v-if="errors.has(item.id + 'timestamp')">{{ errors.first(item.id + 'timestamp') }}</span>
            </md-field>
          </md-table-cell>
          <md-table-cell>
            <md-field :class="{'md-invalid': errors.has(`${item.id}_percent`)}">
              <md-input v-model="item.percent"
                        data-vv-as="percent"
                        :name="item.id + '_percent'"
                        v-validate="'required|min_value:0|decimal:18'"
                        data-vv-validate-on="none"
                        type="number"></md-input>
              <span style="position: absolute; right: 15px; top: 50%;">%</span>
              <span class="md-error" v-if="errors.has(`${item.id}_percent`)">{{ errors.first(`${item.id}_percent`) }}</span>
            </md-field>
          </md-table-cell>
          <md-table-cell>
            <md-button class="md-raised md-button-primary" @click="showConfirmUpdate(item)">Save</md-button>
          </md-table-cell>
        </md-table-row>
      </template>
    </data-table>

    <md-dialog-confirm
      :md-active.sync="isShowConfirmGenerate"
      md-title="Are you sure you want to generate?"
      md-confirm-text="Agree"
      md-cancel-text="Disagree"
      @md-cancel="onCancelConfirm"
      @md-confirm="onConfirmGenerate"/>
    <md-dialog-confirm
      :md-active.sync="isShowConfirmUpdate"
      md-title="Are you sure you want to update?"
      md-confirm-text="Agree"
      md-cancel-text="Disagree"
      @md-cancel="onCancelConfirm"
      @md-confirm="onConfirmUpdate"/>
  </div>
</template>

<script>
  import rf from '../../common/requests/RequestFactory';
  import DatetimePicker  from '../components/DatetimePicker.vue';
  import bignumber from 'bignumber.js';

  export default {
    components: {
      DatetimePicker
    },
    data () {
      return {
        params: {},
        isShowConfirmUpdate: false,
        isShowConfirmGenerate: false,
        recordWillUpdate: {},
      }
    },
    methods: {
      showDialogConfirmGenerate(record) {
        this.$validator.validateAll('generate')
          .then((result) => {
              if (!result) {
                return;
              }

            this.isShowConfirmGenerate = true;
            this.recordWillUpdate = record;
          });
      },

      async showConfirmUpdate(record) {
        const results = await Promise.all([
          this.$validator.validate(`${record.id}_timestamp`),
          this.$validator.validate(`${record.id}_percent`),
        ]);

        const areValid = results.every(isValid => isValid);
        if (areValid) {
          this.isShowConfirmUpdate = true;
          this.recordWillUpdate = record;
        }
      },

      onConfirmGenerate() {
        this.createBonus(this.recordWillUpdate);
      },

      onConfirmUpdate() {
        this.updateBonus(this.recordWillUpdate);
      },

      onCancelConfirm() {
        this.recordWillUpdate = {};
        this.refreshDataTable();
      },

      createBonus (params) {
        rf.getRequest('BonusRequest').create({
          timestamp: params.end_time,
          percent: bignumber(`${params.percent}`).div(100).toString(),
        }).then(() => {
          this.params = {};
          this.recordWillUpdate = {};
          this.$toasted.show(' Bonus added successfully!', {
            theme: 'bubble',
            position: 'bottom-right',
            duration : 1500
          });
          this.refreshDataTable();
        });
      },

      refreshDataTable() {
        this.$refs.datatable.refresh();
      },

      async updateBonus(bonus) {
        rf.getRequest('BonusRequest').update(bonus.id, {
          timestamp: bonus.timestamp,
          percent: bignumber(`${bonus.percent}`).div(100).toString(),
        }).then(() => {
          this.refreshDataTable();
          this.recordWillUpdate = {};
          this.$toasted.show('Bonus updated successfully!', {
            theme: 'bubble',
            position: 'bottom-right',
            duration : 1500
          });
        });
      },

      getBonuses(params) {
        if (!params.sortField && !params.sortDirection) {
          Object.assign(params, {sortField: 'timestamp', sortDirection: 'desc'});
        }
        return rf.getRequest('BonusRequest').getAdminBonuses(params);
      }
    },
    mounted() {
      this.$refs.datatable.$on('DataTable:finish', () => {
        this.$refs.datatable.rows.forEach((row) => {
          row.percent = bignumber(`${row.percent}`).times(100).toString();
        });
      });
    }
  }
</script>

<style lang="scss">
  .getBonuses {
    .md-card .md-card-content {
      padding: 0px;
    }
  }
</style>

<style lang="scss" scoped>
  .md-field-search {
    max-width: 400px;
  }

  .md-card .md-card-content {
    padding: 0px 20px;
  }

  .md-card {
    margin: 0px;
  }
</style>
